#!/usr/bin/perl -w



# odeskejpuje specialni SQL znaky
sub qs{
  my($s)=@_;
  
  if (!defined($s)) {return undef;}
  $s=~s/'/''/g;
  $s=~s/\\/\\\\/g;
  return $s;
}

sub db_connect{
  my ($dbhost, $dbname, $dbuser, $dbpw)=@_;
  
  $db=DBI->connect("DBI:Pg:".
                     "dbname=$dbname;".
                     "host=$dbhost;",
                   $dbuser,
                   $dbpw)
    or die "Can't connect to database: ".DBI->errstr."\n";
                                                           

}


sub db_disconnect{
  $db->disconnect();
}


sub db_exec{
  my ($query)=@_;
  my ($q);
  
#  print Dumper $query;
#  print $query."\n";
  $q=$db->prepare($query) or die $db->errstr;
  $q->execute();

  return $q;
}


sub db_begin{
    $db->{AutoCommit}=0;
   #     or die "Can't begin transaction: ".DBI->errstr."\n"; # muze zhavarovat?
}

sub db_commit{
#    print "--COMMIT--\n";
    $db->commit
        or die "Can't commit transaction: ".DBI->errstr."\n";
    if ($@) {
        warn "Transaction aborted because $@";
        $db->rollback; # undo the incomplete changes
        # add other application on-error-clean-up code here
        die "commit FAILED";
    }


}

sub db_abort{
    db_exec("abort") or die "Can't abort transaction: ".DBI->errstr."\n";
}


sub db_query{
    my ($query)=@_;
    my ($q,@line);

    $q=db_exec($query) or die "Can't exec '$query'";
    @line=$q->fetchrow_array();
    $q->finish();
    return $line[0];
}


sub db_numrows{
    my ($query)=@_;
    my ($q,$a);

    $q=db_exec($query) or die "Can't exec '$query'";
    $n=$q->rows;
    $q->finish();
    return $n;
}


sub db_die{
    die $_[0]." ".DBI->errstr;
}

# zformatuje SQL prikaz podle fmt, prida eskejpovane argumenty @args na misto %
sub fs{
    my ($fmt, @args)=@_;
    my $ret = '';

    foreach my $c (split //,$fmt){
        if ($c eq '%'){
            my $a = shift @args;
            if (defined($a)){
                $ret .= "'".qs($a)."'";
            }else{
                $ret .= ' IS NULL';  # todo not null podle konce fmt
            }
            next;
        }
        $ret .= $c;
    };
    return $ret;
}

sub getrawcall{
    my ($call)=@_;
    my (@parts)=split /\//,uc($call);
    my ($part);
    foreach $part (@parts){
        next if (length($part)<3);
        next if ($part =~ /^..[0-9]$/); # 3rd char cannot be number , OK1 vs G8M
        return $part;
    }
    return uc($call);
}


1;
