<?
# ěščřžýáíé

if (file_exists("local.php")){
    require "local.php";
}

# db example:
#    $db=pg_connect($PG_CONNECT_STRING);
#    if (!$db) die("Can't connect to database");


function dump($var,$text=""){
  global $NODUMP;  
  if ($NODUMP) return;

  print "<font color=darkred>";
  
  if (Is_Integer($var) or Is_Double($var)){
    print "--dump $text '</font>".qh($var)."<font color=darkred>'<br>";
  }  
  elseif (Is_String($var)){
      $s = qh($var);
//    $s = preg_replace('/\\\/', '\\\\', $s);
      $s = preg_replace('/\r/', '<font color=red>\\r</font>', $s);
      $s = preg_replace('/\n/', '<font color=red>\\n</font>', $s);
    print "--dump $text '</font>".$s."<font color=darkred>'<br>";
  }  
  elseif (Is_Array($var)){
    print "--dump array $text: <br>";
    #for ($i=reset($var); current($var); next($var)){  
    #  print " &nbsp; &nbsp; &nbsp; [".qh(key($var))."]='".qh(current($var))."'<br>\n";
    #}
    foreach (array_keys($var) as $key){
      print " &nbsp; &nbsp; &nbsp; [".qh($key)."]='".qh($var[$key])."'<br>";
    }
    print "--end<br>";
  }
  elseif (Is_Object($var)){
    print "--dump: object ".get_class($var)."<br>";
    switch(get_class($var)){
        case "DOMElement":
            print " &lt;".$var->tagName."&gt;";
            break;
    }
    print "<br>";
  } 
  elseif (Is_bool($var)){
    print "--dump $text '</font>".($var?'true':'false')."<font color=darkred>'<br>";
  }
  elseif (IsSet($var)){
    print "--dump: unknown type $text<br>";
  }
  else {
    print "--dump: undef $text<br>";
  }
  print "</font>\n";
}

function dumpline($var,$text=""){
  global $NODUMP;  
  if ($NODUMP) return;
  
  print "<font color=darkred>";
  if (Is_Array($var)){
    print "--dump array $text: <br>\n";
    for ($i=reset($var); current($var); next($var)){  
      if ((1+key($var)) != 1 or key($var) == "0") continue;
      print " &nbsp; &nbsp; &nbsp; [".qh(key($var))."]='".qh(current($var))."'<br>\n";
    }
    print "--end<br>\n";
  }
  elseif (IsSet($var)){
    print "--dump: unknown type $text<br>\n";
  }
  else {
    print "--dump: undef $text<br>\n";
  }
  print "</font>";
}
# odeskejpuje specialni SQL snaky
function qs($a){
#  dump($a);
  $a = pg_escape_string($a);
#  dump($a);
  return $a;
}

# odeskejpuje specialni HTML znaky
function qh($a){
  $a=HtmlSpecialCHars("".$a);
  $a=str_replace("'","&#39;",$a);
  return $a;
}

# odeskejpuje specialni URL znaky, mezeru predela na +
function qu($a){
  return URLEncode($a);
}

# odeskejpuje specialni URL znaky, mezeru predela na %20
function qf($a){
  return RawURLEncode($a);
}

# zformatuje SQL prikaz podle retezce fmt. Znaky % nahradi eskejpovanymi argumenty
function fs($fmt){
    if (is_null($fmt)) return "NULL";
    $ret="";
    $len=strlen($fmt);
    $j=1;
    for ($i=0;$i<$len;$i++){
        $c=substr($fmt, $i, 1);
        if ($c!='%'){
            $ret.=$c;
            continue;
        }
        if (is_null(func_get_arg($j))){
            if (preg_match("/=$/", $ret)){
                $ret=preg_replace("/=$/","",$ret);
                $ret.=" IS NULL";
            }
            if (preg_match("/<>$/", $ret)){
                $ret=preg_replace("/<>$/","",$ret);
                $ret.=" NOT NULL";
            }
        }else{
            $ret.="'".qs(func_get_arg($j))."'";
        }
        $j++;
    }
    return $ret;
}

# zformatuje URL podle retezce fmt. Znaky % nahradi eskejpovanymi argumenty
function fu($fmt){
    $ret="";
    $len=strlen($fmt);
    $j=1;
    for ($i=0;$i<$len;$i++){
        $c=substr($fmt, $i, 1);
        if ($c!='%'){
            $ret.=$c;
            continue;
        }
        $ret.=qu(func_get_arg($j++));
    }
    return $ret;
}

# zformatuje HTML podle retezce fmt. Znaky % nahradi eskejpovanymi argumenty
function fh($fmt){
    $ret="";
    $len=strlen($fmt);
    $j=1;
    for ($i=0;$i<$len;$i++){
        $c=substr($fmt, $i, 1);
        if ($c!='%'){
            $ret.=$c;
            continue;
        }
        $ret.=qh(func_get_arg($j++));
    }
    return $ret;
}

# zformatuje SQL insert, typicke pouziti:
# $h[name]="abc";
# $q=finsert("items", $h, "id='%'", $id); 
function finsert($table, $qhash,$dhash){
    $k="";
    $v="";
    if (is_array($qhash)){
        foreach ($qhash as $key => $value){
            if (strlen($k)) $k.=",";
            $k.=$key;
            if (strlen($v)) $v.=",";
            if (is_null($value)){
                $v.="NULL";
            }else{
                $v.=fs("%", $value);
            }
        }
    }
    if (is_array($dhash)){
        foreach ($dhash as $key => $value){
            if (strlen($k)) $k.=",";
            $k.=$key;
            if (strlen($v)) $v.=",";
            if (is_null($value)){
                $v.="NULL";
            }else{
                $v.=$value;
            }
        }
    }
    $ret="insert into $table($k) values($v)";
    return $ret;
}

function fupdate($table, $qhash, $dhash, $fmt, $arg){
    $s="";
    $ret="";
#            foreach ($qhash as $key => $value){
#            }
    if (is_array($qhash)){
        foreach ($qhash as $key => $value){
            if (strlen($s)) $s.=",";
            if (is_null($value)){
                $s.="$key=NULL";
            }else{
                $s.=fs("$key=%", $value);
            }
        }
    }
    if (is_array($dhash)){
        foreach ($dhash as $key => $value){
            if (strlen($s)) $s.=",";
            if (is_null($value)){
                $s.="$key=NULL";
            }else{
                $s.="$key=$value";
            }
        }
    }
    
    $w="";
    $len=strlen($fmt);
    $j=4;
    for ($i=0;$i<$len;$i++){
        $c=substr($fmt, $i, 1);
        if ($c!='%'){
            $w.=$c;
            continue;
        }
        $w.="'".qs(func_get_arg($j++))."'";
    }
    $ret.="update $table set $s where $w";
    return $ret;
}


function pgerror($msg){
  $pgerr=Pg_ErrorMessage();
  $pgerr=Preg_Replace('/ERROR: */i','',$pgerr);
  error($msg."<br><br>\nReason:<br>\n$pgerr");
}

function NumRows($query){
  global $db;
  
#  print "--NumRows('$query')<br>\n";
  $q = Pg_Exec($db, $query);
  $ret = Pg_NumRows($q);
#  print "--returns $ret<br>\n";
  return $ret;
}

function pg_scalar($query){
  global $db;

  //dump($query,"query");
  $q = Pg_Exec($db, $query);
  if (!$q) return null;
  $count = Pg_NumRows($q);
  if ($count < 1) return null;
  $row = Pg_Fetch_Array($q, 0);
  $ret = $row[0];
  return $ret;
}

function pg_row($query){
  global $db;

  //dump($query,"query");
  $q = Pg_Exec($db, $query);
  if (!$q) return null;
  $count = Pg_NumRows($q);
  if ($count < 1) return null;
  $row = Pg_Fetch_Array($q, 0);
  return $row;
}


function datefromsql($sql){
    $dny=array("Ne", "Po", "Út", "St", "Čt", "Pá", "So");
    if (strlen($sql)==0) return NULL;

    $ar=split("[ .:-]", $sql);
#   dump($ar);
    $ret['year']=$ar[0];
    $ret['mon']=$ar[1];
    $ret['mday']=$ar[2];
    $ret['hours']=$ar[3];
    $ret['minutes']=$ar[4];
    $ret['seconds']=$ar[5];
    $lt=localtime(mktime($ar[3], $ar[4], $ar[5], $ar[1], $ar[2], $ar[0]), 1);
#   dump($lt);
    $ret['wday']=$dny[$lt['tm_wday']];
#   dump($ret);
    return $ret;
}

# vstup je pole jako od getdate()
function hrdate($date){
    if (count($date)==0) return "";
    return sprintf("%s %d.%d.%d", $date['wday'], $date['mday'], $date['mon'], $date['year']);
}

# vstup je pole jako od getdate()
function hrdatetime($date){
    if (count($date)==0) return "";
    if ($date['hours'] > 0 && $date['minutes'] > 0 && $date['seconds'] > 0)
        return sprintf("%s %d.%d.%d %d:%02d:%02d", $date['wday'], $date['mday'], $date['mon'], $date['year'], $date['hours'], $date['minutes'], $date['seconds']);
    elseif ($date['hours'] > 0)
        return sprintf("%s %d.%d.%d %d:%02d", $date['wday'], $date['mday'], $date['mon'], $date['year'], $date['hours'], $date['minutes']);
    else        
        return sprintf("%s %d.%d.%d", $date['wday'], $date['mday'], $date['mon'], $date['year']);
    
}

function zgetdir($src){
    if (!strchr($src, '/')) return '';
    $s = preg_replace('/^(.*)\/(.*?)$/', '$1', $src);
    return $s;
}

function zgetfile($src){
    $s = preg_replace('/^(.*)\/(.*?)$/', '$2', $src);
    return $s;
}

function zgetrawfile($src){
    $s = zgetfile($src);
    if (!strchr($src, '.')) return $src;
    $s = preg_replace('/^(.*)(\..*?)$/', '$1', $s);
    return $s;
}
                            
                            
function zgetext($src){
    $s = zgetfile($src);
    if (!strchr($src, '.')) return '';
    $s = preg_replace('/^(.*)(\..*?)$/', '$2', $s);
    return $s;
}
    
    
function test_zgetfiles(){    
    $s = "/home/ja.old/soubor.jpeg";
    $s = '/etc';
    echo "<br>";
    dump($s, 's');
    echo "<br>";
    dump(zgetdir($s), "path");
    dump(zgetfile($s), "file");
    dump(zgetrawfile($s), "rawfile");
    dump(zgetext($s), "ext");
}

function zmkdir_p($dir, $mode = 0777){
    if ($dir == "") return;
    if (is_dir($dir)) return;
    $d = zgetdir($dir);
    if (zmkdir_p($d) === false) return false;
    if (@mkdir($dir, $mode) === false) return false;
    if (@chmod($dir, $mode) === false) return false;
    return true;
}           

function zis_mobile(){
#    if (isset($_SERVER['HTTP_X_OPERAMINI_PHONE']) && $_SERVER['HTTP_X_OPERAMINI_PHONE'] == 'Motorola # MOTOROKR Z6') return true;
#    if (isset($_SERVER['HTTP_USER_AGENT']) && preg_match('/MOTOROKR\ Z6/', $_SERVER['HTTP_USER_AGENT']) > 0) return true;
#    if (isset($_SERVER['HTTP_USER_AGENT']) && $_SERVER['HTTP_USER_AGENT'] == 'Mozilla/5.0 (compatible; MSIE 8.0; Windows CE; PPC; 600x800)') return true;

    return false;
}

function zis_anonymizer(){
    if (isset($_SERVER['HTTP_USER_AGENT'])){
        if (preg_match('/anonym/i', $_SERVER['HTTP_USER_AGENT'])) return true; 
    }
    return false;
}

function z_anonymizer_joke(){
    print "<div style='margin:1em; padding:1em; border: 2px solid white; color: white; background-color: red; display:table;'><b>Anonymizer error</b><br>Form has been sent including your private informations.</div>\n";
}


function zget_raw_call($src){
    $src = strtoupper($src);
    $a = explode(":", $src);
    foreach ($a as $c){
        if (strlen($c) < 3) continue;
        if (strlen($c) == 3 && $c[2] >= '0' && $c[2] <= '9') continue;
        return $c;
    }
    return $src;
}

function zfirefox_get_contents($url){
    $opts = array(
        'http'=>array(
            'method'=>"GET",
            'protocol_version'=>'1.1',
            'header'=>"User-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:28.0) Gecko/20100101 Firefox/28.0\r\n".
                      "Accept: text/html,*/*\r\n".
                      "Accept-language: en\r\n" .
                      "Connection: close\r\n"
        )
    );

    $context = stream_context_create($opts);
    return file_get_contents($url, false, $context);
}

function z_baseurl(){
    return "http://".$_SERVER['SERVER_NAME'].dirname($_SERVER['PHP_SELF']);
}

function z_mail($to, $subject, $body, $attachments){

    $cmd = "mutt -s '$subject' '$to'";
    if (is_array($attachments)){
        foreach ($attachments as $att){
            $cmd .= " -a '$att'";
        }
    }else{
        if (isset($attachments)) $cmd .= " -a '$attachments'";
    }

    $fd = popen($cmd, "w");
    if ($fd){
        fwrite($fd, $body);
        fclose($fd);
    }
}


$ZLOC_R_EARTH = 6371.2907;

function qth($wwl, $isw){
    $wwl = strtoupper($wwl);
    $i = $isw ? 1 : 0;

    if ($wwl[$i] < 'A' || $wwl[$i] > 'R') return -100 - $i;
    $ret = (ord($wwl[$i]) - ord('J')) * pi() / 9.0;
    $i += 2;

    if ($wwl[$i] < '0' || $wwl[$i] > '9') return -100 - $i;
    $ret += (ord($wwl[$i]) - ord('0')) * pi() / 90.0;
    $i += 2;

    if ($wwl[$i] < 'A' || $wwl[$i] > 'X') return -100 - $i;
    $ret += (ord($wwl[$i]) - ord('A')) * pi() / 2160.0;

    $ret += pi() / 4320.0;
    if ($isw) $ret /= 2.0;
    return $ret;
}


function qrbqtf2hw($h1, $w1, $qrb, $qtf, &$h2, &$w2){
    global $ZLOC_R_EARTH;

    if ($qrb > $ZLOC_R_EARTH * pi()) return -1;
    $d = $qrb / $ZLOC_R_EARTH;

    $w2 = asin(sin($w1) * cos($d) + cos($w1) * sin($d) * cos($qtf));
    if (abs(cos($w2)) < 0.00000000005){
        $hw = 0.0;
    }else{
        $dh = atan2(sin($qtf) * sin($d) * cos($w1),
                    cos($d) - sin($w1) * sin($w2));
        $h2 = fmod(pi() + $h1 + $dh, 2 * pi()) - pi();
    }

    return 0;
}

function z_is_content_type($contenttype){
    if (!isset($_SERVER["CONTENT_TYPE"])) return false;
    $s = $_SERVER["CONTENT_TYPE"];
    //dump($s);
    $i = strpos($s, ';');
    if ($i > 0) $s = substr($s, 0, $i);
    $s = trim($s);
    $s = strtolower($s);
    //dump($s);
    $conenttype=strtolower($contenttype);
    //dump($contenttype);
    return $s == $contenttype;
}

?>
